/*
 *             Automatically Tuned Linear Algebra Software v3.9.14
 *                    (C) Copyright 2008 R. Clint Whaley
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *   1. Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice, this list of conditions, and the following disclaimer in the
 *      documentation and/or other materials provided with the distribution.
 *   3. The name of the ATLAS group or the names of its contributers may
 *      not be used to endorse or promote products derived from this
 *      software without specific written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
 * TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE ATLAS GROUP OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */
#include "atlas_misc.h"
#include "atlas_f77.h"
#include "atlas_C2Flapack.h"

#if defined(NoChange)
   #define F77GERQF Mjoin(PRE,gerqf)
#elif defined (UpCase)
   #define F77GERQF Mjoin(PREU,GERQF)
#elif defined (Add_) || defined(Add__)
   #define F77GERQF Mjoin(PRE,gerqf_)
#endif
#define PC2F Mjoin(ATL_C2F,PRE)

int Mjoin(PC2F,gerqf_wrk)(ATL_CINT M, ATL_CINT N, TYPE *A, ATL_CINT lda,
                          TYPE *tau, TYPE *wrk, ATL_INT lwork)
{
   F77_INTEGER F77M=M, F77N=N, F77lda=lda, F77lwork=lwork, F77info;
   void F77GERQF(F77_INTEGER *M, F77_INTEGER *N, TYPE *A, F77_INTEGER *lda,
                 TYPE *tau, TYPE *wrk, F77_INTEGER *lwork, F77_INTEGER *info);

   F77GERQF(&F77M, &F77N, A, &F77lda, tau, wrk, &F77lwork, &F77info);
   return(F77info);
}

int Mjoin(PC2F,gerqf)(ATL_CINT M, ATL_CINT N, TYPE *A, ATL_CINT lda, TYPE *tau)
{
   TYPE tmp[2];
   TYPE *work;
   ATL_INT lwork, info;
/*
 * Get workspace requirements, do allocation, and call routine for real
 */
   ATL_assert(!Mjoin(PC2F,gerqf_wrk)(M, N, A, lda, tau, tmp, -1));
   lwork = tmp[0];
   work = malloc(lwork*ATL_sizeof);
   ATL_assert(work);
   info = Mjoin(PC2F,gerqf_wrk)(M, N, A, lda, tau, work, lwork);
   free(work);
   return(info);
}
